<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="渠道名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入渠道名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:channel:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="channelList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="channelId" width="80"/>
      <el-table-column label="渠道名称" align="center" prop="name"/>
      <el-table-column label="图片" align="center" prop="picture" width="100">
        <image-preview slot-scope="d" :src="d.row.picture" :width="32" :height="32"/>
      </el-table-column>
<!--      <el-table-column label="是否启用" align="center" prop="enabled">-->
<!--        <template slot-scope="d">-->
<!--          <el-switch v-model="d.row.enabled" @change="(nv) => {onChangeEnabled(d.row, nv)}"/>-->
<!--        </template>-->
<!--      </el-table-column>-->
      <el-table-column label="渠道成本" align="center" prop="costRate">
        <template slot-scope="d">{{d.row.costRate | money}} %</template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:channel:edit']"
          >修改</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改充值渠道对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="7em">
        <form-col :span="span" label="渠道名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入渠道名称"  disabled readonly/>
        </form-col>
        <form-col :span="span" label="图片" prop="picture">
          <image-upload v-model="form.picture" :limit="1"/>
        </form-col>
<!--        <form-col :span="span" label="是否启用" prop="enabled">-->
<!--          <el-switch v-model="form.enabled" />-->
<!--        </form-col>-->
        <form-col :span="span" label="渠道成本" prop="costRate">
          <el-input v-model.number="form.costRate"  placeholder="请输入充值成本率" :min="0">
            <template #suffix>%</template>
          </el-input>
        </form-col>
        <h2 style="font-weight: 700;font-size: 18px">相关配置</h2>
        <el-row>
          <el-col :span="12">
            <el-form-item label="商户号" prop="merchantId">
              <el-input style="width: 100%" v-model="form.merchantId" placeholder="请输入商户号" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="apiV3密钥" prop="apiV3Key">
              <el-input v-model="form.apiV3Key" placeholder="请输入apiV3密钥" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="通知回调地址" label-width="100" prop="notifyUrl">
              <el-input style="width: 66%" v-model="form.notifyUrl" placeholder="请输入通知回调地址" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="密钥所在位置" label-width="100" prop="privateKeyPath">
              <el-input style="width: 70%" v-model="form.privateKeyPath" placeholder="请输入密钥所在位置" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="证书序列号" label-width="90"  prop="merchantSerialNumber">
              <el-input style="width: 70%" v-model="form.merchantSerialNumber" placeholder="请输入证书序列号" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="退款回调地址" label-width="100" prop="refundNotifyUrl">
              <el-input style="width: 70%" v-model="form.refundNotifyUrl" placeholder="请输入退款回调地址" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listChannel, getChannel, delChannel, addChannel, updateChannel } from "@/api/system/channel";
import { $serviceType, $withdrawServiceType } from '@/utils/mixins'

export default {
  name: "Channel",
  mixins: [$serviceType, $withdrawServiceType],
  dicts: ['withdraw_service_type', 'service_type'],
  data() {
    return {
      span: 24,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 充值渠道表格数据
      channelList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        enabled: null,
        serviceRate: null,
        costRate: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          {required: true, message: '渠道名称不能为空', target: 'blur'}
        ],
        // enabled: [
        //   {required: true, type: 'boolean', message: '是否启用不能为空', target: 'blur'}
        // ],
        costRate: [
          {required: true, type: 'number', message: '成本不能为空', target: 'blur'}
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    parseNumber(val) {
      if (val == null) {
        return null;
      }
      return parseFloat(val);
    },
    // 更新是否启用
    // onChangeEnabled(row, enabled) {
    //   if (row == null) {
    //     return this.$message.warning("参数错误");
    //   }
    //   updateChannel({channelId: row.channelId, enabled: enabled}).catch(() => {
    //     row.enabled = !enabled;
    //   })
    // },
    onChangeWithdrawEnabled(row, enabled) {
      if (row == null) {
        return this.$message.warning("参数错误");
      }
      updateChannel({channelId: row.channelId, withdrawEnabled: enabled}).catch(() => {
        row.withdrawEnabled = !enabled;
      })
    },
    /** 查询充值渠道列表 */
    getList() {
      this.loading = true;
      listChannel(this.queryParams).then(response => {
        this.channelList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        channelId: null,
        name: null,
        enabled: null,
        serviceRate: null,
        costRate: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.channelId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加充值渠道";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const channelId = row.channelId || this.ids
      getChannel(channelId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改充值渠道";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.channelId != null) {
            updateChannel(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addChannel(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const channelIds = row.channelId || this.ids;
      this.$modal.confirm('是否确认删除充值渠道编号为"' + channelIds + '"的数据项？').then(function() {
        return delChannel(channelIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/channel/export', {
        ...this.queryParams
      }, `channel_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
